/*
 *  TIMERS, {akii-root}/src/timers.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#include <stdio.h>
#include <sys/time.h>
#include <signal.h>
#include "timers.h"
#include "main.h"

/*Ennyi sec. lesz az idozito ideje, ha lejar, SIGALRM
   es ujraindul, de akkor noveljuk az 'inc'et is INTERVAL-lal!
   20000000 eseten 231 napig ez nem kovetkezik be! :-) */
#define INTERVAL 20000000

/*increment, ha sigalarm volt INTERVALlal */
long timerinc = 0;
int inicializalt = 0;
struct itimerval itv;

void sigALRM(int signo)
{
/*        printf("\n\nSIGALRM\n\n"); */
    getitimer(ITIMER_REAL, &itv);
    if ((!(itv.it_value.tv_sec * itv.it_value.tv_usec)) || (itv.it_value.tv_sec >= INTERVAL - 1)) {
	timerinc += INTERVAL;
    }
    signal(SIGALRM, sigALRM);
    return;
}

void inittimers(void)
{
    signal(SIGALRM, sigALRM);
    itv.it_interval.tv_sec = INTERVAL;
    itv.it_interval.tv_usec = 0;
    itv.it_value.tv_sec = INTERVAL;
    itv.it_value.tv_usec = 0;
    setitimer(ITIMER_REAL, &itv, NULL);
    inicializalt = 1;
    return;
}
int startstopper(struct timeval2 *tv2)
{
    if (!tv2)
	return (1);
    if (!inicializalt)
	return (2);
    getitimer(ITIMER_REAL, &itv);
    tv2->tv.tv_sec = itv.it_value.tv_sec;
    tv2->tv.tv_usec = itv.it_value.tv_usec;
    tv2->minc = timerinc;
    return (0);
}
long stopstopper(struct timeval2 *tv2)
{
    int sec, msec;

/*      char temp[400]; */

    if (!tv2)
	return (0);
    if (!inicializalt)
	return (floodprotect);
    getitimer(ITIMER_REAL, &itv);

    sec = tv2->tv.tv_sec - itv.it_value.tv_sec + timerinc - tv2->minc;
    msec = tv2->tv.tv_usec - itv.it_value.tv_usec;
    if (msec < 0) {
	sec--;
	msec += 1000000;
    }
    msec /= 1000;
    return (sec * 1000 + msec);
}
void delay(long msec)
{
    struct timeval to;

    to.tv_sec = msec / 1000;
    to.tv_usec = (msec % 1000) * 1000;
    fflush(stdout);
    select(0, NULL, NULL, NULL, &to);
    return;
}
